﻿// update TVS:  PROD-6216: change field to look at when displaying message
using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Data;
using System.Globalization;
using System.Reflection;
using System.Text;
//using System.Transactions;
using Produmex.Foundation;
using Produmex.Foundation.Barcode;
using Produmex.Foundation.Data;
using Produmex.Foundation.Data.Sbo;
using Produmex.Foundation.Data.Sbo.BusinessObjects;
using Produmex.Foundation.Data.Sbo.BusinessObjects.Convertors;
using Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions;
using Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.Tables;
using Produmex.Foundation.Data.Sbo.DataObjects;
using Produmex.Foundation.Data.Sbo.Providers;
using Produmex.Foundation.Data.Sbo.Utilities;
using Produmex.Foundation.Data.SqlClient;
using Produmex.Foundation.Diagnostics;
using Produmex.Foundation.GS1;
using Produmex.Foundation.Messages;
using Produmex.Foundation.SlimScreen;
using Produmex.Foundation.SlimScreen.Interfaces;
using Produmex.Foundation.SlimScreen.Interfaces.Definitions;
using Produmex.Foundation.SlimScreen.Interfaces.Definitions.DataObjects;
using Produmex.Foundation.SlimScreen.Interfaces.Definitions.KnownDataSets;
using Produmex.Foundation.SlimScreen.WinGui;
using Produmex.Foundation.Utilities;
using Produmex.Foundation.Workflows;
using Produmex.Foundation.Workflows.Parameters;
using Produmex.Foundation.Wwf.Sbo;
using Produmex.Foundation.Wwf.Sbo.DataObjects;
using Produmex.Foundation.Wwf.Sbo.LocalServices;
using Produmex.Sbo.Logex.Data.BusinessObjects;
using Produmex.Sbo.Logex.Data.BusinessObjects.Definitions;
using Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.Tables;
using Produmex.Sbo.Logex.Data.DataObjects;
using Produmex.Sbo.Logex.Data.Devices;
using Produmex.Sbo.Logex.Data.Generators.BatchNumberGenerators;
using Produmex.Sbo.Logex.Data.Generators.PackingController;
using Produmex.Sbo.Logex.Data.Providers;
using Produmex.Sbo.Logex.Data.ViewObjects.Definitions.Views;

namespace WorkflowScript_PickingAfterItemToPickIdentifiedHookScript.Kor
{
    public class WorkflowScript_PickingAfterItemToPickIdentifiedHookScript : WorkflowInstanceScriptBase
    {
        private static readonly ILog s_log = LogProvider.GetLogger(MethodInfo.GetCurrentMethod().DeclaringType);

        // Input parameters * do not change *
        public ReadOnlyBinder<CultureInfo> DefaultCultureInfo;
        public ReadOnlyBinder<PmxOseCompany> PmxOseCompany;

        public ReadOnlyBinder<PickingItemInfo> PickingItemInfo;

        // Output parameters * do not change *
        public ReadWriteBinder<bool> BackRequested;

        // Sub-flows
        // <none>


        public WorkflowScript_PickingAfterItemToPickIdentifiedHookScript(WorkflowInstanceBase parent, WorkflowInstanceFactory factory)
            : base(parent, factory)
        {
        }

        #region WorkflowInstanceScriptBase Members

        protected override void Execute()
        {
            // Parameters in scope
            Session session = GetScopeParameter("Session") as Session;
            ISboProviderService sboProviderService = GetScopeParameter("<WwfService>ISboService") as ISboProviderService;
            Message msg = null;
            PickingItemInfo itemInfo = PickingItemInfo;

            string query = BuildQuery.GetQueryParameter16(itemInfo.ItemCode);
            DataSet ds = sboProviderService.RunView(false, null, null, query);

            if (GetNrOfRows(ds) > 0)
            {
                //string qryGroup16 = ds.Tables[0].Rows[0][SboItemTable.Columns.QryGroup16.NAME].ToString();
		    int NbrOfPackages = (int) ds.Tables[0].Rows[0]["U_NbrOfPackages"];

                //if (qryGroup16.ToUpper() == "Y")
		    if (NbrOfPackages > 1)

                {
                    session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                        this.DefaultCultureInfo, BuildParamCollection(
                        "MessageKey", "Verpakking bestaat uit " + NbrOfPackages.ToString() + " delen",
                        "ShowButton", true
                        ));
                    msg = WaitForMessage();
                }
            }
        }

        #endregion

        private int GetNrOfRows(DataSet ds)
        {
            return (ds != null && ds.Tables.Count > 0) ? ds.Tables[0].Rows.Count : 0;
        }

        #region QUERY

        private class BuildQuery
        {
            public static string GetQueryParameter16(string itemCode)
            {
                StringBuilder strBuilder = new StringBuilder();

                strBuilder.AppendFormat("SELECT U_NbrOfPackages FROM {0}",
                    //SqlCommandHelper.EscapeTableColumnName(SboItemTable.NAME, SboItemTable.Columns.QryGroup16.NAME),
			  //SqlCommandHelper.EscapeTableColumnName(SboItemTable.NAME, SboItemTable.Columns.U_NbrOfPackages.NAME),
                    SqlCommandHelper.EscapeTableName(SboItemTable.NAME));

                strBuilder.AppendFormat("\r\nWHERE {0} = {1}",
                    SqlCommandHelper.EscapeTableColumnName(SboItemTable.NAME, SboItemTable.Columns.ItemCode.NAME),
                    SqlCommandHelper.FormatAndEscapeColumnValue(itemCode, CultureInfo.CurrentCulture));

                return strBuilder.ToString();
            }
        }

        #endregion
    }
}